package client.listener;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;

import javax.swing.JButton;

import client.model.Communicator;
import client.view.AnonymousWindow;

public class AnonymousListener implements MouseListener {

	private static final String LOGOUT_ERROR = "Error logging out!";

	private Communicator communicator;
	private AnonymousWindow window;

	public AnonymousListener(Communicator communicator) {
		this.communicator = communicator;
	}

	@Override
	public void mouseClicked(MouseEvent event) {
		JButton button;

		if (event.getSource() instanceof JButton) {
			button = (JButton) event.getSource();
			String label = button.getText();
			String message;
			String id;

			if (label.equals(AnonymousWindow.SEND_LABEL)) {
				id = window.getId();				
				message = window.getMessage();
				if (id != null) {
					window.addText(communicator.getUser().getName() + ": " + message);
					try {
						communicator.send(message, id);
					} catch (IOException e) {
						window.addText("Error communicating with server");
					}	 catch (Exception e) {
						
					}				
				}
			} else if (label.equals(AnonymousWindow.LOGOUT_LABEL)) {
				try {
					communicator.logout();
				} catch (IOException e) {
					window.addText(LOGOUT_ERROR);
				} catch (Exception e) {
					
				}
			} else if (label.equals(AnonymousWindow.CLOSE_LABEL)) {
				communicator.triggerRemoveUser(window.getId());
			}
		}
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub

	}

	public void setAnonymousWindow(AnonymousWindow anonymousWindow) {
		this.window = anonymousWindow;		
	}

}
