package client.listener;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import common.Error;


import client.model.Communicator;
import client.model.AnonymousUser;
import client.model.HelpDeskUser;
import client.view.AnonymousLoginWindow;
import client.view.HelpDeskLoginWindow;
import client.view.LoginWindow;

public class LoginListener implements MouseListener {
		
	private Communicator communicator;
	
	private LoginWindow window;
	
	public LoginListener(Communicator communicator) {
		this.communicator = communicator;
	}

	@Override
	public void mouseClicked(MouseEvent event) {
		/* No need to check which button since there is only one.*/
		try {
			//String userType = window.getUserType();
			String username = window.getUserName();
			AnonymousUser user;
			
			if (window instanceof AnonymousLoginWindow) {
				user = new AnonymousUser();
				user.setName(username);
				communicator.setUser(user);
				communicator.login(username);
			} else if (window instanceof HelpDeskLoginWindow) {
				HelpDeskLoginWindow hdlw = (HelpDeskLoginWindow) window;
				user = new HelpDeskUser();
				user.setName(username);
				String password = hdlw.getPassword();
				communicator.setUser(user);
				communicator.login(username, password);
			} else {
				//Unknown user
				window.setMessage(Error.UNKNOWN_ERROR);
				return;
			}
			
			
		} catch (Exception e) {
			window.setMessage(Error.UNKNOWN_ERROR);
		}
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// DO NOTHING
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// DO NOTHING
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// DO NOTHING
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// DO NOTHING
	}
	
	public void setLoginWindow(LoginWindow window) {
		this.window = window;
	}
}
