package client.view;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.GroupLayout.ParallelGroup;

import common.Common;


import client.listener.LoginListener;

public class AnonymousLoginWindow extends LoginWindow {

	private static final long serialVersionUID = 4112313970057908287L;

	public AnonymousLoginWindow(LoginListener listener) {
		GroupLayout layout = new GroupLayout(this.getContentPane());
		JButton login = new JButton(LOGIN);
		login.addMouseListener(listener);
		listener.setLoginWindow(this);
		
		this.setLayout(layout);
		layout.setAutoCreateContainerGaps(true);
		layout.setAutoCreateGaps(true);
		
		ParallelGroup horizontal = layout.createParallelGroup()
				.addComponent(prompt, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
			.addComponent(login, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
			.addGroup(layout.createSequentialGroup()
						.addGroup(layout.createParallelGroup()
								.addComponent(usernameLabel, GroupLayout.PREFERRED_SIZE, 
										GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						)
						.addGroup(layout.createParallelGroup()
								.addComponent(usernameField, GroupLayout.PREFERRED_SIZE, 
										GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						)
			);
				
		layout.setHorizontalGroup(horizontal);		
		
		layout.setVerticalGroup(
			layout.createSequentialGroup()
				.addGroup(layout.createParallelGroup()
					.addComponent(usernameLabel, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					.addComponent(usernameField, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					)
				.addComponent(login, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
				.addComponent(prompt, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
			);
				
		this.setTitle(TITLE);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.pack();
		Common.centerAlign(this);
		this.setVisible(true);
	}	
}
