package client.view;

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import common.Common;


import client.listener.AnonymousListener;
import client.listener.HelpDeskListener;
import client.model.AnonymousUser;

public class AnonymousWindow extends JFrame {

	private static final long serialVersionUID = -6206480077670981918L;
	private static final String TITLE = "Chat Program";
	private static final int INPUT_FIELD_WIDTH = 35;
	private static final int TEXT_AREA_HEIGHT = 20;
	private static final int HEIGHT = 600;	
	private static final int WIDTH = 800;
	
	public static final String SEND_LABEL = "SEND";
	public static final String LOGOUT_LABEL = "LOGOUT";
	public static final String CLOSE_LABEL = "CLOSE";
	
	protected AnonymousUser user;
	
	private JButton end;
	private boolean isHelpDeskChat;
	private JTextArea text;	
	private JTextField input;
	private AnonymousListener listener;
	
	public AnonymousWindow(AnonymousListener listener) {
		super();
		
		user = new AnonymousUser();
		
		this.setListener(listener);
		listener.setAnonymousWindow(this);
		
		text = new JTextArea(TEXT_AREA_HEIGHT, INPUT_FIELD_WIDTH);
		text.setEditable(false);
		
		this.add(new JScrollPane(text), BorderLayout.CENTER);
		
		JPanel panel = new JPanel(new FlowLayout());
	
		input = new JTextField(50);
		end = new JButton(LOGOUT_LABEL);
		JButton send = new JButton(SEND_LABEL);
		
		end.addMouseListener(listener);
		send.addMouseListener(listener);
		
		panel.add(end);
		panel.add(input);
		panel.add(send);
		
		this.add(panel, BorderLayout.SOUTH);
		
		this.setSize(WIDTH, HEIGHT);
		Common.centerAlign(this);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setTitle(TITLE);			
	}
	
	public AnonymousWindow(HelpDeskListener listener, boolean isHelpDeskChat) {
		this(listener);
		this.isHelpDeskChat = isHelpDeskChat;
		if(isHelpDeskChat) {
			end.setText(CLOSE_LABEL);
		}
	}

	public String getMessage() {
		return input.getText();
	}
	
	public void addText(String message) {
		text.append(message + "\n");
	}
	
	public String getId() {
		return user.getId();
	}

	public void setId(String username) {
		this.user.setId(username);
		/*if (username == null) {
			setTitle(TITLE);
		} else {
			setTitle("Chat with " + username);
		}*/
	}
	
	public AnonymousUser getUser() {
		return user;
	}

	public AnonymousListener getListener() {
		return listener;
	}

	public void setListener(AnonymousListener listener) {
		this.listener = listener;
	}
}
