package client.view;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;

import common.Common;


import client.listener.ConnectListener;

public class ConnectWindow extends JFrame {
	
	private static final long serialVersionUID = -6616259017123590885L;	
	private static final String TITLE = "Connect to Server";	
	private static final String URL_LABEL = "URL";	
	private static final String PORT_LABEL = "Port";	
	private static final int FIELD_WIDTH = 20;

	public static final String CONNECT = "Connect";	
	
	private JTextField urlField;
	private JTextField portField;	
	private JLabel prompt;
		
	/**/
	public ConnectWindow(ConnectListener other) {
		super(TITLE);
		
		JLabel urlLabel = new JLabel(URL_LABEL);
		JLabel portLabel = new JLabel(PORT_LABEL);
		prompt = new JLabel("");
		JButton connect = new JButton(CONNECT);
		urlField = new JTextField(FIELD_WIDTH);
		portField = new JTextField(FIELD_WIDTH);
		
		GroupLayout layout = new GroupLayout(this.getContentPane());
		ConnectListener listener = other;
		listener.setWindow(this);		
		connect.addMouseListener(listener);
		
		this.setLayout(layout);
		layout.setAutoCreateContainerGaps(true);
		layout.setAutoCreateGaps(true);	
		
		layout.setHorizontalGroup(
			layout.createParallelGroup()
				.addComponent(prompt, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
				.addComponent(connect, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
				.addGroup(layout.createSequentialGroup()
							.addGroup(layout.createParallelGroup()
									.addComponent(urlLabel, GroupLayout.PREFERRED_SIZE, 
											GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
									.addComponent(portLabel, GroupLayout.PREFERRED_SIZE, 
											GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							)
							.addGroup(layout.createParallelGroup()
									.addComponent(urlField, GroupLayout.PREFERRED_SIZE, 
											GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
									.addComponent(portField, GroupLayout.PREFERRED_SIZE, 
											GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							)
				)
			);
		
		layout.setVerticalGroup(
			layout.createSequentialGroup()
				.addGroup(layout.createParallelGroup()
					.addComponent(urlLabel, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					.addComponent(urlField, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					)
				.addGroup(layout.createParallelGroup()
					.addComponent(portLabel, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					.addComponent(portField, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					)
				.addComponent(connect, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
				.addComponent(prompt, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
			);

		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.pack();
		Common.centerAlign(this);
	}	
	
	public String getUrl() {
		return urlField.getText();
	}

	public String getPort() {
		return portField.getText();
	}
	
	public void setMessage(String message) {		
		prompt.setText(message);
	}
}
