package client.view;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.GroupLayout.ParallelGroup;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPasswordField;

import common.Common;


import client.listener.LoginListener;

public class HelpDeskLoginWindow extends LoginWindow {
	
	private static final long serialVersionUID = -498337301715676102L;	
	
	private final String PASSWORD_LABEL = "Password";	
	
	private JPasswordField passwordField;	
	private JLabel passwordLabel;	

	public HelpDeskLoginWindow(LoginListener listener) {
		GroupLayout layout = new GroupLayout(super.getContentPane());
		passwordLabel = new JLabel(PASSWORD_LABEL);
		JButton login = new JButton(LOGIN);
		
		passwordField = new JPasswordField(FIELD_WIDTH);
		
		login.addMouseListener(listener);
		listener.setLoginWindow(this);
		
		
		this.setLayout(layout);
		layout.setAutoCreateContainerGaps(true);
		layout.setAutoCreateGaps(true);
		
		ParallelGroup horizontal = layout.createParallelGroup()
				.addComponent(prompt, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
			.addComponent(login, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
			.addGroup(layout.createSequentialGroup()
						.addGroup(layout.createParallelGroup()
								.addComponent(usernameLabel, GroupLayout.PREFERRED_SIZE, 
										GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(passwordLabel, GroupLayout.PREFERRED_SIZE, 
										GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						)
						.addGroup(layout.createParallelGroup()
								.addComponent(usernameField, GroupLayout.PREFERRED_SIZE, 
										GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
								.addComponent(passwordField, GroupLayout.PREFERRED_SIZE, 
										GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
						)
			);
				
		layout.setHorizontalGroup(horizontal);
		
		
		
		layout.setVerticalGroup(
			layout.createSequentialGroup()
				.addGroup(layout.createParallelGroup()
					.addComponent(usernameLabel, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					.addComponent(usernameField, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					)
				.addGroup(layout.createParallelGroup()
					.addComponent(passwordLabel, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					.addComponent(passwordField, GroupLayout.PREFERRED_SIZE, 
							GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
					)
				.addComponent(login, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
				.addComponent(prompt, GroupLayout.PREFERRED_SIZE, 
						GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
			);
				
		this.setTitle(TITLE);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.pack();
		Common.centerAlign(this);
		this.setVisible(true);
	}	
	
	public String getPassword() {
		return String.valueOf(passwordField.getPassword());
	}
}
