package common;

import java.awt.Dimension;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.swing.JFrame;

public class Common {

	private Common() {	
	}
	
	public static String [] tokensToArray(StringTokenizer tokenizer) {
		return tokensToArray(tokenizer, null);
	}
	
	public static String []tokensToArray(StringTokenizer tokenizer, String excludeString) {
		String token;
		Vector<String> usernames = new Vector<String>();

		while (tokenizer.hasMoreTokens()) {
			token = tokenizer.nextToken();
			if (excludeString != null) {
				if (!token.equals(excludeString)) {
					usernames.add(token);
				}
			} else {
				usernames.add(token);
			}
		}
		
		String [] array = new String [usernames.size()];
		usernames.toArray(array);
		return array;
	}
	
	public static void centerAlign(JFrame frame) {
		Dimension dim = java.awt.Toolkit.getDefaultToolkit().getScreenSize();		
		frame.setLocation((dim.width - frame.getWidth()) / 2, (dim.height - frame.getHeight()) / 2);			
	}
}
