package common;

import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.KeyFactory;
import java.security.NoSuchAlgorithmException;
import java.security.interfaces.RSAPrivateKey;
import java.security.interfaces.RSAPublicKey;
import java.security.spec.RSAPrivateKeySpec;
import java.security.spec.RSAPublicKeySpec;
import java.util.Random;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.CipherInputStream;
import javax.crypto.CipherOutputStream;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;


public class MessageDigest {

	private SecretKey AES_key;
	IvParameterSpec AES_IV;
	byte[] IVV; 
	Cipher cipher;
	
		
	public MessageDigest () throws NoSuchAlgorithmException, NoSuchPaddingException
	{	
		cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
		IVV = hexToBytes("20FC19123087BF6CAC8D0F1254123004");  // this is a default 8 blocks vector
		AES_auto_generate_key();
	}
	
	public SecretKey get_key()
	{
		return this.AES_key;
	}
	public byte[] get_IVV()
	{
		return this.IVV;
	}
	public void set_key(byte[] key)
	{
		this.AES_key = new SecretKeySpec(key, "AES");
	}
	
	public void set_IVV(byte[] iv)
	{
		this.IVV = iv;
	}
	
	public void AES_auto_generate_key() throws NoSuchAlgorithmException
	{
		KeyGenerator kgen = KeyGenerator.getInstance("AES");
		kgen.init(128);
		AES_key = kgen.generateKey();
		//Key secret = new SecretKeySpec(key, "AES");
		AES_IV = new IvParameterSpec(IVV);
	}
	
	public byte[] AES_encrypt (String msg) throws InvalidKeyException, InvalidAlgorithmParameterException, IllegalBlockSizeException, BadPaddingException
	{
		//Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
		cipher.init(Cipher.ENCRYPT_MODE, AES_key, AES_IV);
		byte[] ciphertext = cipher.doFinal(msg.getBytes());
		return ciphertext;
	}

	public String AES_decrypt (byte [] msg) throws InvalidKeyException, InvalidAlgorithmParameterException, IllegalBlockSizeException, BadPaddingException
	{
		//Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
		cipher.init(Cipher.DECRYPT_MODE, AES_key, AES_IV);
		byte[] plaintext = cipher.doFinal(msg);
		return new String(plaintext);
	}
	
	public  byte[] hexToBytes(String str)
	   {
	   if ((str.length() % 2) == 1) str = "0" + str; // pad leading 0 if needed
	       byte[] buf = new byte[str.length() / 2];
	       int i = 0;

	       for (char c : str.toCharArray())
	       {
	           byte b = Byte.parseByte(String.valueOf(c), 16);
	           buf[i/2] |= (b << (((i % 2) == 0) ? 4 : 0));
	           i++;
	       }

	       return buf;
	   }
	public static String bytesToHex(byte[] data)
	   {
		  //avoid sign extension, add: intVar & 0xFF		   
		  StringBuffer buffer = new StringBuffer();
		  for (int i = 0; i < data.length; i++)
		  {
			  int tmp = data[i] & 0xFF;
			  if (tmp < 16)
			  buffer.append("0");
			  buffer.append(Integer.toHexString(tmp));	  
		  }
		  return buffer.toString().toUpperCase();
	   }
 	
	
	public String AES_key_generator1 ()
	{
		char[] chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ01234567890@#!_-?".toCharArray();
		StringBuilder sb = new StringBuilder();
		Random random = new Random();
		for (int i = 0; i < 20; i++) {
		    char c = chars[random.nextInt(chars.length)];
		    sb.append(c);
		}
		return sb.toString();
	}
	
	
	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
				
		String msg = "alksdjfa alsdfj9873 lakf @#$%^&*() laksjf lskdfjfpwlk"; 
		MessageDigest convertor = new MessageDigest();
		
		System.setProperty("sun.jnu.encoding", "ISO-8859-1");
		System.setProperty("file.encoding", "ISO-8859-1");
		
		System.out.println("=====================");
		convertor.AES_auto_generate_key();
		byte [] c = convertor.AES_encrypt(msg);
		//String x = convertor.AES_encrypt(msg);
		String x = new String(c, "ISO-8859-1");
		System.out.println(x);
		byte [] d = x.getBytes("ISO-8859-1");
		String e = new String(d);
		
		String y = convertor.AES_decrypt(e.getBytes("ISO-8859-1"));
		System.out.println(y);
		System.out.println(y.equals(msg));
	}
	

}
