package server;

import java.io.*;
import java.net.*;
import java.util.*;

import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;

import common.MessageDigest;

public class CServer
{
	private  Hashtable<String, HelpDeskDirectory> help_desk_account;  // it stores help desk informations
	private  Hashtable<String, ChatDirectory> chat_dir = new  Hashtable<String, ChatDirectory>();					// it stores chat directory on the server
	private MessageDigest server_AES;
	private int client_ID = 0;			// it issues username ID for ANONYMOUS USER
	final private int MAX_THREAD_NUM = 512;
	private int thread_counter = 0;
	private SSLServerSocket openSocket;

    SSLServerSocketFactory sslServerSocketFactory;
	//private boolean listening = true;
	
	Scanner input = new Scanner(System.in);
	
	
	public CServer(int port_number, MessageDigest server_AES, Hashtable<String, HelpDeskDirectory> helpD_Account) throws Exception
	{
		System.setProperty("javax.net.ssl.keyStore", "keystore.jks");
		System.setProperty("javax.net.ssl.keyStorePassword", "123456");
		this.openSocket = (SSLServerSocket) SSLServerSocketFactory.getDefault().createServerSocket(port_number);
		this.openSocket.setEnabledCipherSuites(this.openSocket.getEnabledCipherSuites());
		this.server_AES = server_AES;
		this.help_desk_account = helpD_Account;
	}
	
	public void get_started() 
	{
		try{
		
			while(true) 
			{	
				//SSLSocket connectSockets = (SSLSocket) openSocket.accept(); 
				Socket connectSockets =  openSocket.accept(); 
					
					if(thread_counter <= MAX_THREAD_NUM)		// it checks if the thread is not over 512
					{
						thread_counter++;
						ServerThread thread = new ServerThread(this, connectSockets);			
						Thread start_thread = new Thread(thread);
						start_thread.start(); //start new thread to allow multiple connections to port
					}
					else
					{
						DataOutputStream output = new DataOutputStream(connectSockets.getOutputStream());
						output.writeBytes("cmd_connection: " + "BUSY" +"\n");							// if the server has reached 512 threads
					}
			}
		}catch (Exception e) {
			//e.printStackTrace();
			//System.out.println("something\n");
		}
	}
	
		
	// Sample help desk account info
	public boolean check_string_length(String word, int length)
	{
		return (word.length() > length);
	}
	public boolean uname_format(String format1, String format2, String format3, String word)
	{
		boolean d = false, e = false, g = false;
		for (int i = 0; i < word.length(); i++)
        {
           int a = format1.indexOf(word.charAt(i));
           int b = format2.indexOf(word.charAt(i));
           int c = format3.indexOf(word.charAt(i));
           if(!(a == -1)) d = true;
           if(!(b == -1)) e = true;
           if(!(c == -1)) g = true;       
        }
		
		return ((d && e && g))? true : false;
	}
	public boolean pass_format(String format1, String format2, String format3, String format4, String word)
	{
		boolean d = false, e = false, g = false, f = false;
		for (int i = 0; i < word.length(); i++)
        {
           int a = format1.indexOf(word.charAt(i));
           int b = format2.indexOf(word.charAt(i));
           int c = format3.indexOf(word.charAt(i));
           int z = format4.indexOf(word.charAt(i));
          
           if(!(a == -1)) d = true;
           if(!(b == -1)) e = true;
           if(!(c == -1)) g = true; 
           if(!(z == -1)) f = true;
        }		
		return ((d && e && g & f))? true : false;
	}
	public void add_new_helpdesk()
	{
		boolean quit = true;
		boolean uname_new = false;
		boolean pass_new = false;
		String small_Letters= "abcdefghijklmnopqrstuvwxyz";
		String capital_Letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		String numbers = "0123456789";
		String symbols = "@#&";
		
		System.out.println("Enter first name : ");
		String fname = input.next();
		System.out.println("Enter last name : ");
		String lname = input.next();
		
		System.out.println("Enter user name - it should be more than 8 characters long, contains numbers or/and letters of small and capital letter: ");
		String uname = "";
		uname = input.next();
		for(; !uname.equals("q") && quit; )
		{
			if (!uname_format(small_Letters, capital_Letters, numbers, uname) || !check_string_length(uname, 8) || this.help_desk_account.containsKey(uname))
			{
				System.out.println("Try another user name. To quit, please enter 'q'");
				uname = input.next();
			}
			else
			{
				quit = false;
				uname_new = true;
			}
		}
				
		quit = true;
		System.out.println("Enter password - it should be more than 10 characters long, contains at least samll and capital letters, numbers and symbols : ");
		String pass;
		pass = input.next();
		for(; !pass.equals("q") && quit; )
		{
			if (!check_string_length(pass, 10) || !pass_format(small_Letters, capital_Letters, numbers, symbols, pass))
			{
				System.out.println("Try another user name. To quit, please enter 'q'");
				pass = input.next();
			}
			else
			{
				quit = false;
				pass_new = true;
			}
		}
		
		
		if(uname_new && pass_new)
		{
			HelpDeskDirectory temp = new HelpDeskDirectory(fname.toUpperCase(), lname.toUpperCase());
			temp.set_userName(uname);
			temp.set_password(pass);
			this.help_desk_account.put(uname, temp);
			
			System.out.println("The user name is: " + uname);
			System.out.println("The password name is: " + pass);
			System.out.println("Successfully added!!!");
		}
		else
		{
			System.out.println("Operation failed, try again next time");
		}		
	}
	
	public void delete_HelpDesk()
	{
		System.out.println("Enter the user name : ");
		String username = input.next();
		if(!help_desk_account.isEmpty())
		{
			if(help_desk_account.containsKey(username))
			{
				help_desk_account.remove(username);
				System.out.println("Sucessfully Deleted!");
			}
			else
			{
				System.out.println("The user name doesn't exist. Operation Failed!!");
			}
		}
	}
	
	public void get_stastics()
	{
		String data[][] = new String[512][5];
		int count = 0;
		if(!help_desk_account.isEmpty())
		{
			String tempname;		
			Set<String> set = help_desk_account.keySet();

		    Iterator<String> itr = set.iterator();
		    int row = 0;
	//	    int col = 0;
		    while (itr.hasNext() && row < 512)
		    {
			    tempname = itr.next();
			    data[row][0] = tempname; 	// User name
			    data[row][1] = help_desk_account.get(tempname).get_firstName();	// first name
			    data[row][2] = help_desk_account.get(tempname).get_lastName();	// Last name

			    if(chat_dir.containsKey(tempname))
		      	{
			    	data[row][3] = "Yes";	// log in
			    	data[row][4] = chat_dir.get(tempname).total_client_list() + " ";		    		
		      	}
			    else
			    {
			    	data[row][3] = "No"; data[row][4] = "--";		    	
			    }
			    row++;
		    }
		    count = row;
		}
		
	    System.out.println("UserName\tFName\t\tLName\t\tLogin\t\t Total No. Anonymous user assisting");
	    System.out.print("___________________________________________________________________________");
	    System.out.println("___________________________________");
	    for(int row = 0 ; row < count; row++)
	    {
	    	for(int col = 0; col < 5; col++)
	    	{
	    		System.out.print(data[row][col] + "\t\t");
	    	}
	    	System.out.println("");
	    }
	}
	
	/*public void set_listening_mode(boolean onOff)
	{
		this.listening = onOff;
	}*/
	/*
	 * This method deduct one from thread counter when the user end their chat session
	 */
	public void thread_out()
	{
		this.thread_counter--;
	}
	/*
	 *It issues a unique ID for ANONYMOUS USER 
	 */
	public int create_client_ID()
	{
		int temp;
		temp = this.client_ID++;
		return temp;
	}
	
	/*
	 * This method add a new user account in chat directory.
	 * It can be ANONYMOUS USER or help desker accessing server
	 */
	public void add_chat_dir(ChatDirectory dir)
	{
		chat_dir.put(dir.get_userName(), dir);
	}
	
	/*
	 * This method check  if the help desk is in the chat directory
	 */
	public boolean check_HDesk_byuserName(String username)
	{
		if(help_desk_account.isEmpty())
		{
			return false;
		}
		else if (help_desk_account.containsKey(username))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	/*
	 *This method checks if the help desk's user name and password are corret.
	 *It will return true if it matches with the database else flase.
	 */
	public boolean login_check(String username, String pass)
	{
		if (this.check_HDesk_byuserName(username))
		{
			return (help_desk_account.get(username)).check_pass(pass);
		}
		else
		{
			return false;
		}
	}
	
	/*
	 * This method returns fist name of the help desk from the database
	 */
	public String get_HelpD_FName(String username)
	{
		if (this.check_HDesk_byuserName(username))
		{
			return (help_desk_account.get(username)).get_firstName();
		}
		else
			return "";
	}
	
	/*
	 * This method returns the first name of a user(Help Desk or Anonymous user) from chat directory
	 */
	public String get_chat_dir_FName(String username)
	{
		if(this.chat_dir_username_exsit(username))
		{
			return chat_dir.get(username).get_firstName();
		}
		else
			return null;
	}
	
	/*
	 * It checks if the user(either Help Desk or Anonymous) is on Chat Directory
	 * Given a username, it returns ture if it exist else flase
	 */
	public boolean chat_dir_username_exsit(String username)
	{
		if(chat_dir.isEmpty())
		{
			return false;
		}
		else if (chat_dir.containsKey(username))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	/*
	 * This method will return a list of all login Help Desk username
	 * The return value String is a concatenated user names.
	 */
	public boolean anonymous_exist_on_chat_dir(DataOutputStream output)
	{
		
		if(chat_dir.isEmpty())
		{
			return false;
		}
		String tempname;
		Set<String> set = chat_dir.keySet();

	    Iterator<String> itr = set.iterator();			    
	    while (itr.hasNext())
	    {
		    tempname = itr.next();
		    if(((chat_dir.get(tempname).get_userType()) == 0 ) && (chat_dir.get(tempname).get_CurrentDatastrem().equals(output)))
		      	{
		    	  return true;
		      	}
	    }
	    
	    return false;
	}
	
	/*
	 * This method returns the assigned chat partner user name.
	 * It can be Help Desk or Anonymous user. If it doesn't have chat partner, it returns null
	 */
	public String get_assigned_username(String username)
	{
		if(chat_dir_username_exsit(username))
		{
			if ((this.get_chat_dir(username)).get_assigned_username() != null)
			{
				return (this.get_chat_dir(username)).get_assigned_username();
			}
		}
		else
		{
			return null;
		}
		return null;
	}
	
	/*
	 * This method returns a user(can be Anonymous user or Help Desk) Chat Directory node.
	 * It returns the Chat Directory node or null if the user doesn't exit
	 */
	public ChatDirectory get_chat_dir(String username)
	{
		if(chat_dir.isEmpty() || !chat_dir_username_exsit(username))
		{
			return null;  // empty list
		}
		else
		{
			return chat_dir.get(username);
		}
	}
	
	/*
	 * This method checks if the Anonymous user has assigned Help Desk OR
	 * if the Help Desk has assigned anonymous user. 
	 * It returns true if it has assigned user name or false if it doesn't.
	 */
	public boolean has_client(String username)
	{
		if(this.chat_dir_username_exsit(username))
		{
			return (this.get_chat_dir(username).get_status()) == 1;  //it has client and return true
		}
		
		return false;
	}
	
	/*
	 * This method checks if the Help Desk is ready to accept new customer 
	 * The Help Desk can activate or de-activate at any time
	 * It returns true if the Help Desk is ready to accept new customer, else it is false
	 */
	public boolean check_request(String username)
	{
		if(this.chat_dir_username_exsit(username))
		{
			return (this.get_chat_dir(username).get_request()) == 1; //it is ready to accept new client
		}
		
		return false;
	}
	
	/*
	 * This method check if the Anonymous user is active. Active means the user is on Chat directory
	 * either waiting for Help Desk or chatting with Help Desk. 
	 * Not active means, the Anonymous user finished chatting with the help desk. The server is not going to
	 * assign to Help Desk
	 * It returns true, if the user is being assisted by the Help Desk
	 */
	public boolean check_activate(String username)
	{
		if(this.chat_dir_username_exsit(username))
		{
			return (this.get_chat_dir(username).get_acivate()) == 1; //check if the anonymous  user is active 
		}
		
		return false;
	}
	
	/*
	 * This method will remove a user(Anonymous or Help Desk) from chat directory.
	 */
	public void remove_user(String username)
	{
		if(chat_dir_username_exsit(username))
		{
			chat_dir.remove(username);
		}
	}
	
	/*
	 * This method will return a list of all login Help Desk username
	 * The return value String is a concatenated user names.
	 */
	public String get_all_HDesk_userName()
	{
		String names = "";
		if(chat_dir.isEmpty())
		{
			return null;
		}
		String tempname;
		Set<String> set = chat_dir.keySet();

	    Iterator<String> itr = set.iterator();			    
	    while (itr.hasNext())
	    {
		    tempname = itr.next();
		    if(((chat_dir.get(tempname).get_userType()) == 1 ))
		      	{
		    	  names = names + " " + tempname;
		      	}
	    }
	    
	    return (names != "")? names : null;
	}
	
	/*
	 * This method will return a Help desk username that is unassigned and ready to assist Anonymous user
	 * from chat directory
	 * It will return null if all the logged in Help Desk are busy or the chat directory is empty
	 */
	public String get_Transfer_To_HelpD_List()
	{
		String names = "";
		if(chat_dir.isEmpty())
		{
			return null;
		}
		String tempname;
		Set<String> set = chat_dir.keySet();

	    Iterator<String> itr = set.iterator();			    
	    while (itr.hasNext())
	    {
		    tempname = itr.next();
		    if(((chat_dir.get(tempname).get_userType()) == 1 ) && ((chat_dir.get(tempname).get_transfer_mode()) == 1))
		      	{
		    	  names = names + " " + tempname;
		      	}
	    }
	    
	    return (names != "")? names : null;
	}
	
	/*
	 * This method bring any Anonymous user that is waiting to be assisted and active
	 * It will return null if there is no anonymous user
	 */
	public String client_wait_tobe_assign( )
	{
		if(chat_dir.isEmpty())
		{
			return null;  // empty list
		}
		String tempname;
		Set<String> set = chat_dir.keySet();
	    Iterator<String> itr = set.iterator();			    
	    while (itr.hasNext())
	    {
		    tempname = itr.next();
		    if(((chat_dir.get(tempname).get_userType()) == 0) && !(this.has_client(tempname)) && (this.check_activate(tempname)))
		      	{
		    	  return tempname;
		      	}
	    }
	    
	    return null; // no one is waiting
	}
	
	/*
	 * This method select a Help Desk who is ready to be assign and not busy with helping a customer
	 * It will return null if no Help Desk is available
	 */
	public String helpD_wait_tobe_assign()
	{
		if(chat_dir.isEmpty())
		{
			return null;  // empty list
		}
		String tempname;
		Set<String> set = chat_dir.keySet();
	    Iterator<String> itr = set.iterator();
	    int max = 0;
	    while (itr.hasNext())	// get the maximum total number of assigned client to Help desk
	    {
		    tempname = itr.next();
		    if(((chat_dir.get(tempname).get_userType()) == 1) && (this.check_request(tempname)))
	      	{
		    	if(chat_dir.get(tempname).total_client_list() >= max)
		    	{
		    		max = chat_dir.get(tempname).total_client_list();
		    	}
	      	}
	    }
	    itr = set.iterator();
	    while (itr.hasNext())	// equal distribution of client to Help Desk
	    {
		    tempname = itr.next();
		    if(((chat_dir.get(tempname).get_userType()) == 1) && (this.check_request(tempname)))
	      	{
		    	if(max == 0)		// there is no client assigned to Help Desk, pick one from the first
		    	{
		    		return tempname;
		    	}
		    	if(chat_dir.get(tempname).total_client_list() < max)	// go through the chat directory who has smaller number of clients
		    	{
		    		return tempname;
		    	}
	      	}
	    }
	    itr = set.iterator();
	    while (itr.hasNext())	// all Help Desk have equal number of clients , so pick the first one to be assigned
	    {
		    tempname = itr.next();
		    if(((chat_dir.get(tempname).get_userType()) == 1) && (this.check_request(tempname)))
	      	{
		    	return tempname;	
	      	}
      	}	    
	    return null; // no one is waiting
	}
	
	/*
	 * This method assign a help desk with Anonymous user who is waiting to be served
	 * It will return true if the Help Desk is assigned, else false.
	 */
	public boolean helpdesk_assignment(String HDesk_username, String com_Notify, String com_Msg)
	{
		String assigned_anonymous = client_wait_tobe_assign();	// pick an Anonymous user who is waiting to be assign

		if(assigned_anonymous != null && (check_request(HDesk_username)))
		{	
			get_chat_dir(HDesk_username).set_request(0);			// set the Request status back to 0 until new request comes
			get_chat_dir(assigned_anonymous).set_status(1);		
			get_chat_dir(assigned_anonymous).set_assigned_username(HDesk_username); 
			get_chat_dir(HDesk_username).add_client_list(assigned_anonymous);  // add to the assigned client list
			
			try{
				String FName = this.get_chat_dir_FName(assigned_anonymous);
				String statement = com_Notify + HDesk_username + "\n";
				send_msg(this.get_chat_dir(assigned_anonymous).get_CurrentDatastrem(), statement);
				//this.get_chat_dir(assigned_anonymous).get_CurrentDatastrem().writeBytes(com_Notify + HDesk_username + "\n");	//this notify the client side window to whom it is assigned
				statement = com_Notify + assigned_anonymous + "\n";
				send_msg(this.get_chat_dir(HDesk_username).get_CurrentDatastrem(), statement);
				//this.get_chat_dir(HDesk_username).get_CurrentDatastrem().writeBytes(com_Notify + assigned_anonymous + "\n");  // this notify the client side window to whom it is assigned
				statement = com_Msg + assigned_anonymous + " You are now assigned to help  " + FName + "\n";
				send_msg(this.get_chat_dir(HDesk_username).get_CurrentDatastrem(), statement);
				//this.get_chat_dir(HDesk_username).get_CurrentDatastrem().writeBytes(com_Msg + "SERVER" + " You are now assigned to help a Client name called " + FName + "\n");
				statement = com_Msg + assigned_anonymous + " Start chatting...." + "\n";
				send_msg(this.get_chat_dir(HDesk_username).get_CurrentDatastrem(), statement);
				//this.get_chat_dir(HDesk_username).get_CurrentDatastrem().writeBytes(com_Msg + "SERVER" + " Start chatting...." + "\n");
				
			} catch(Exception e) {}
			
			return true;												
		}
		
		return false;
	}
	
	/*
	 * This method assign an Anonymous user with Help Desk who is available and ready
	 * It will return true if the Anonymous user is assigned, else false.
	 */
	public boolean anonymous_user_assignment(String anonymous_username, String com_Notify, String com_Msg)
	{
		String assigned_HDesk = helpD_wait_tobe_assign();			//pick Help Desk for assignment of a client
		if(assigned_HDesk != null && !(has_client(anonymous_username)) && (this.check_activate(anonymous_username)))
		{									
			get_chat_dir(assigned_HDesk).set_request(0); 			//// set the Request status back to 0 until new request comes
			get_chat_dir(anonymous_username).set_status(1);
			get_chat_dir(assigned_HDesk).add_client_list(anonymous_username);  // add to the assigned client list
			get_chat_dir(anonymous_username).set_assigned_username(assigned_HDesk);
			try{
				String FName = this.get_chat_dir_FName(anonymous_username);
				//this.get_chat_dir(anonymous_username).get_CurrentDatastrem().writeBytes(com_Notify + assigned_HDesk + "\n");	//this notify the client side window to whom it is assigned
				//this.get_chat_dir(assigned_HDesk).get_CurrentDatastrem().writeBytes(com_Notify + anonymous_username + "\n");  // this notify the client side window to whom it is assigned
				//this.get_chat_dir(assigned_HDesk).get_CurrentDatastrem().writeBytes(com_Msg + "SERVER" + " You are now assigned to help a Client name called " + FName + "\n");
				//this.get_chat_dir(assigned_HDesk).get_CurrentDatastrem().writeBytes(com_Msg + "SERVER" + " Start chatting...." + "\n");
				String statement = com_Notify + assigned_HDesk + "\n";
				send_msg(this.get_chat_dir(anonymous_username).get_CurrentDatastrem(), statement);
				statement = com_Notify + anonymous_username + "\n";
				send_msg(this.get_chat_dir(assigned_HDesk).get_CurrentDatastrem(), statement);
				statement = com_Msg + anonymous_username + " You are now assigned to help " + FName + "\n";
				send_msg(this.get_chat_dir(assigned_HDesk).get_CurrentDatastrem(), statement);
				statement = com_Msg + anonymous_username + " Start chatting...." + "\n";
				send_msg(this.get_chat_dir(assigned_HDesk).get_CurrentDatastrem(), statement);
			} catch(Exception e) {}
			
			return true;												
		}
		
		return false;
	}
	
	public void send_msg(DataOutputStream out, String stat) throws IOException 
	{
		out.writeBytes(stat);
	}

}




