package server;
import java.io.DataOutputStream;
import java.io.ObjectOutputStream;
import java.util.Hashtable;
import java.util.LinkedList;

import common.MessageDigest;

/*
 * This class is a node that holds information about Anonymous user or Help Desk users who
 * sign on the Server.
 */

public class ChatDirectory
{
	
	private String user_name;
	private String First_Name;
	private String assigned_username;	// chat partner username. It can be Anonymous user or Help Desk
	
	private DataOutputStream outToCurrent;  //Data output of the current user on the Server.

	private LinkedList <String> assign_list;	//list of Anonymous user assigned for Help Desk
	private int user_type;    			// 1 if it is an Anonymous user or 0 if it is Help Desk
	private int client_helpD_status;	// 1 if it is on chatting mode of 0 if it is in free mode
	private int request;		  		// 1 if the Help Desk is request to be assigned by the server or  0 if it is not request to be assigned
	private int activate;				// 1 If the Anonymous user is activate or 0 is not activate. Active means, the Anonymous user sign in on the server
										// and can be on chatting with a help desk or waiting to be assigned.
	private int transfer_mode;			// 1 if Help Desk is in ready mode for getting Anonymous user from other Help Desk
										// 0 if Help Desk is in not ready mode for getting Anonymous user from other Help Desk
	
	ChatDirectory(String userName, String firstName, int userType, DataOutputStream outToCurrent) // MessageDigest md
	{
		
		this.user_name = userName;
		this.First_Name = firstName;
		this.user_type = userType;
		this.outToCurrent = outToCurrent;
		this.assigned_username = null;
		this.client_helpD_status = 0;
		this.request = 0;
		this.activate = 1;
		this.assign_list = new LinkedList<String>();

	}
	public boolean check_client_list(String client_username)
	{
		return assign_list.contains(client_username);
	}
	public void add_client_list(String client_username)
	{
		assign_list.add(client_username);
	}
	public boolean remove_client_list(String client_username)
	{
		return assign_list.remove(client_username);
	}
	public String remove_client_list(int index)
	{
		return assign_list.remove(index);
	}
	public int total_client_list()
	{
		return assign_list.size();
	}
	public void set_userType(int usertype)
	{
		this.user_type = usertype;
	}
	
	public void set_status(int status)
	{
		this.client_helpD_status = status;
	}
	
	public void set_request(int request)
	{
		this.request = request;
	}
	public void set_transfer_mode(int mode)
	{
		this.transfer_mode = mode;
	}
	public void set_assigned_username(String assigned_name)
	{
		this.assigned_username = assigned_name;
	}
	
	public void set_currentDatastrem(DataOutputStream current)
	{
		this.outToCurrent = current;
	}

	
	public String get_userName()
	{
		return this.user_name;
	}
	
	public String get_firstName()
	{
		return this.First_Name;
	}
	
	public int get_userType()
	{
		return this.user_type;
	}
	
	public int get_status()
	{
		return this.client_helpD_status;
	}
	
	public int get_request()
	{
		return this.request;
	}
	public int get_transfer_mode()
	{
		return this.transfer_mode;
	}
	public String get_assigned_username()
	{
		return this.assigned_username;
	}
	
	public DataOutputStream get_CurrentDatastrem()
	{
		return this.outToCurrent;
	}

	
	public int get_acivate()
	{
		return this.activate;
	}
	
	public void set_activate(int activate)
	{
		this.activate = activate;
	}

}
