package server;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.math.BigInteger;
import java.net.SocketException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Scanner;
import java.util.Set;
import java.util.StringTokenizer;

import common.MessageDigest;

public class ServerDriver
{
	Scanner input = new Scanner(System.in);

	public static void main(String[] args)
	{
        if (args.length != 4) 
        {
        	System.out.println("Usage: [java program] [port number] [filename] [AES KEY] [AES IV]Please try again... ");
			System.exit(0);
        }       
        int port = 0;	
        try {
            port = Integer.parseInt(args[0]);
        } 
        catch (Exception e)
        {
            System.out.println("Port must be an integer between 1 and 65535");
            System.exit(0);
        }       
       if (port < 1 || port > 65535)
       {
           System.out.println("Port must be an integer between 1 and 65535");
           System.exit(0);
       }
      
       String filename = args[1];
        if (args[1] == null || args[1] == "")
       {
    	   System.out.println("File name shouldn't be empty");
           System.exit(0);
       }
	    String set_of_key_characters = "0123456789ABCDEF";		//check the hexadecimal string length
	    if (args[2].length() != 32 || args[3].length() != 32)
	    {
	        System.out.println("Keys must be 32 length of hexadescimal characters each");
	        System.exit(0); 
	    }
        //check for hexadecimal string characters are 0..9A..F
        for (int i = 0; i < 32; i++)
        {
           int a = set_of_key_characters.indexOf(args[2].charAt(i));
           int b = set_of_key_characters.indexOf(args[3].charAt(i));
           if (a == -1 || b == -1)
           {
               System.out.println("Keys must be 32 length of hexadescimal string characters ");
               System.exit(0); 
           }
        }
		
		try
		{
			Scanner input = new Scanner(System.in);
			
			MessageDigest server_AES = new MessageDigest();
			
			Hashtable<String, HelpDeskDirectory> help_desk_account= new Hashtable<String, HelpDeskDirectory>();		
			
			byte[] key = hexToBytes(args[2]);		//getting key
			byte[] IV = hexToBytes(args[3]);		//getting Initial value IV
						
			server_AES.set_key(key);				//setting key
			server_AES.set_IVV(IV);					//setting Inital value IV
			
			try{
				
			//**************Read Data From File***********************			
			read_data_from_File(filename, server_AES, help_desk_account);
			//******************END*******************************
			
			}catch (Exception e) 
				{System.out.println("Error Reading the file. Try again....");
				System.exit(0);}
			
			CServer server = new CServer(port,server_AES, help_desk_account);	// set port number here manually
			
							
			new MainPartitionThread(server).start();		// it separate the listening port with main program for server maintainance
			
			menu();							// a menu will display on terminal for statistic  and Help desk account creation
			for(int select = input.nextInt(); ; select = input.nextInt())
			{
				switch (select)
				{
				case 1:
						server.add_new_helpdesk();
						System.out.println("\n\n");
						menu();
						break;
				case 2:
						server.delete_HelpDesk();
						System.out.println("\n\n");
						menu();
						break;
				case 3:
						change_AES_keys(server_AES);
						System.out.println("\n\n");
						menu();
						break;
					
				case 4:
						backup_accounts(filename, server_AES, help_desk_account);
						System.out.println("\n\n");
						menu();
						break;

				case 5:
						server.get_stastics();
						System.out.println("\n\n");
						menu();
						break;
					
					
				default:
						System.out.println("Invalid input!!!");		
				}
			}
		}
		catch(Exception e) 
		{
			System.out.println("Something wrong with system functionality");
		}
		
		
	}

	/*
	 * This method reads a data from the file and uploaded on array of bytes
	 */
	 public static byte[] fileToBytes(String filename) throws Exception
	   {
		   FileInputStream fis = new FileInputStream(filename);	   
		   ByteArrayOutputStream bos = new ByteArrayOutputStream();
		   byte b;
		   do
		   {	b = (byte) fis.read();
			   if(b != -1) bos.write((byte) b);			   
		   }while(b !=-1);		   
		   byte[] data = bos.toByteArray();
		   fis.close();
		   return data;		   
	   }
	   /** 
	    * Create a file with the given name and wWrite the given array of bytes to it 
	    **/ 
	   public static void stringToFile(String data, String filename) throws Exception
	   {
		   FileOutputStream fos = new FileOutputStream(filename);
		   if(data != "")
		   { 
			   fos.write(data.getBytes()); 
			}
		   fos.close();
	   }
	   /*
	    * it converst array of byte data to a string of hexa decimal characters
	    */
	   public static String bytesToHex(byte[] data)
	   {
		  //avoid sign extension, add: intVar & 0xFF		   
		  StringBuffer buffer = new StringBuffer();
		  for (int i = 0; i < data.length; i++)
		  {
			  int tmp = data[i] & 0xFF;
			  if (tmp < 16)
			  buffer.append("0");
			  buffer.append(Integer.toHexString(tmp));	  
		  }
		  return buffer.toString().toUpperCase();
	   }
	   
	   /**
	    * Convert a string of hex characters to the corresponding byte array.
	    * Each pair of characters in the string represent a byte. If the
	    * given string has an odd number of characters, prepend it with '0'.
	    * @param string an arbitrary string made up of hex characters
	    * @return an array of the bytes represented by the 
	    *        given string.
	    */
	   public static byte[] hexToBytes(String str)
	   {
	   if ((str.length() % 2) == 1) str = "0" + str; // pad leading 0 if needed
	       byte[] buf = new byte[str.length() / 2];
	       int i = 0;
	       for (char c : str.toCharArray())
	       {
	           byte b = Byte.parseByte(String.valueOf(c), 16);
	           buf[i/2] |= (b << (((i % 2) == 0) ? 4 : 0));
	           i++;
	       }
	       return buf;
	   }
	   
	   /*
	    * The method encrypts  data and save it on a specified file
	    */
	   
	   public static void write_data_to_File(String filename, MessageDigest digest, Hashtable<String, HelpDeskDirectory> helpD_Account) throws Exception
		{
			String data = "";
			Set<String> set = helpD_Account.keySet();
		    Iterator<String> itr = set.iterator();
		    while(itr.hasNext())
		    {
		    	String c = itr.next();
		    	HelpDeskDirectory h = helpD_Account.get(c);
		    	data = data + h.toString();					// get each Help Desk name, username and password
		    }
		    byte [] ciphertext = digest.AES_encrypt(data);		//encrypt all the data
			String hex_decimal_ciphertext = bytesToHex(ciphertext);			//convert the byte[] ciphertext into Hexi-decimal representation of String
			stringToFile (hex_decimal_ciphertext, filename);			// Write the ciphertext into a File
			
		}
	   /*
	    * This method retrive encrypted data from specifed filename and decrypt and upload to Help Desk data structure
	    */
		public static void read_data_from_File(String filename, MessageDigest digest, Hashtable<String, HelpDeskDirectory> helpD_Account) throws Exception
		{
			byte [] filedata = fileToBytes(filename);  // read the file and put it on byte array
			String hexData = new String(filedata);		// convert the byte array into hexa decimal representation of string
			byte [] cipher = hexToBytes(hexData);		// convert the hexa decimal representation to byte array 
			String plaintext = digest.AES_decrypt(cipher);	// decrypt encrypted data 
			String [] split_plaintext = plaintext.split("\n");
			String fn = "", ln = "", un = "", ps = "";
			String temp="";
			//boolean mode = true;
			for (int i = 0; i < split_plaintext.length ; i ++)
			{
				StringTokenizer st = new StringTokenizer(split_plaintext[i]);
				temp = st.nextToken();
				switch (temp.charAt(0))
				{
				case 'h':											// Help Desk account info
					if((st.countTokens())== 4)
					{
						fn = st.nextToken();
						ln = st.nextToken();
						un = st.nextToken();
						ps = st.nextToken();				
						helpD_Account.put(un, new HelpDeskDirectory(fn, ln, un, ps));
					}
					break;
				default:	
				}
			}
		}
		
		/*
		 * This method allows to change symmetric keys of AES
		 */
		public static void change_AES_keys(MessageDigest AES)
		{
			boolean valid = true;
			Scanner input = new Scanner(System.in);
			System.out.println("Please Enter the AES key");
			String key = input.nextLine();
			System.out.println("Please Enter the AES IV");
			String IV = input.nextLine();
			String set_of_key_characters = "0123456789ABCDEF";		//check the hexadecimal string length
		    if (key.length() != 32 || IV.length() != 32)
		    {
		        System.out.println("Keys must be 32 length of hexadescimal characters each. Try again");
		        valid = false; 
		    }
	        //check for hexadecimal string characters are 0..9A..F
	        for (int i = 0; i < 32 && valid ; i++)
	        {
	           int a = set_of_key_characters.indexOf(key.charAt(i));
	           int b = set_of_key_characters.indexOf(IV.charAt(i));
	           if (a == -1 || b == -1)
	           {
	               valid = false; 
	           }
	           if (!false) {System.out.println("Keys must be in hexadescimal string characters. Try again ");}
	        }
	        if(valid)
	        {
	        	byte[] k = hexToBytes(key);
				byte[] ivv = hexToBytes(IV);
				AES.set_key(k);
				AES.set_IVV(ivv);
				System.out.println("Successfully changed");
	        }
		}
		
		/*
		 * This method allows the administrator to backup the HelpDesk account info on a specified file
		 */
		public static void backup_accounts(String filename, MessageDigest AES, Hashtable<String, HelpDeskDirectory> helpD_Account)
		{
			Scanner input = new Scanner(System.in);
			System.out.println("Enter the file name ..");
			String file = input.nextLine();
			try {
			write_data_to_File(file, AES, helpD_Account);
			} catch (Exception e) {System.out.println("File not written");}
			System.out.println("Successfully saved");
		}
		
		public static void menu()
		{
			System.out.println("=======================================================");
			
			System.out.println("	   Menu 			      Select");
			System.out.println("	_______________			   _________\n");
			System.out.println("	Add Help Desk user			1");
			System.out.println("	Delete Help Desk user  			2");
			System.out.println("	Change AES key & IV     		3");
			System.out.println("	Backup Accounts on a file		4");
			//System.out.println("	Shut down server			5");
			System.out.println("	Statstics				5");
			
			System.out.println("======================================================");
		}

}
